unit Main_U;

// Main demonstration form.
// http://www.fortunecity.com/skyscraper/true/882/ScramDisk.htm

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, OTFE_U, OTFEScramDisk_U;

type
  TMain_F = class(TForm)
    pbSniff: TButton;
    pbClose: TButton;
    Timer1: TTimer;
    Button1: TButton;
    Label5: TLabel;
    lblRefreshStatus: TLabel;
    edPassword1: TEdit;
    edPassword2: TEdit;
    edPassword3: TEdit;
    edPassword4: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label1: TLabel;
    edRefreshInterval: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label12: TLabel;
    OTFEScramDisk: TOTFEScramDisk;
    pbClearSniffed: TButton;
    Label16: TLabel;
    Label17: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure pbSniffClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure pbCloseClick(Sender: TObject);
    procedure pbClearSniffedClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Main_F: TMain_F;

implementation

{$R *.DFM}

procedure TMain_F.FormCreate(Sender: TObject);
begin
  OTFEScramDisk.active := TRUE;

end;

procedure TMain_F.pbSniffClick(Sender: TObject);
var
  allPasswords: array[1..4] of string;
  passwordsChanged: boolean;
  i: integer;
  j: integer;
begin
  OTFEScramDisk.SniffPassword(allPasswords[1],
                              allPasswords[2],
                              allPasswords[3],
                              allPasswords[4]);

  // We only update the display if valid passwords were sniffed.
  passwordsChanged := FALSE;
  for i:=low(allPasswords) to high(allPasswords) do
    begin
    for j:=1 to length(allPasswords[i]) do
      begin
      if (allPasswords[i][j]<>#0) then
        begin
        passwordsChanged := TRUE;
        break;
        end;
      end;
    end;

  if (passwordsChanged) then
    begin
    edPassword1.text := allPasswords[1];
    edPassword2.text := allPasswords[2];
    edPassword3.text := allPasswords[3];
    edPassword4.text := allPasswords[4];
    end;

end;

procedure TMain_F.Button1Click(Sender: TObject);
begin
  timer1.Interval := strtoint(edRefreshInterval.text);

  if timer1.Interval=0 then
    begin
    showmessage('Interval timer must be a positive integer (try 500)');
    end
  else
    begin
    timer1.enabled := not(timer1.enabled);
    end;

  edRefreshInterval.enabled:=not(timer1.enabled);

  if timer1.enabled=TRUE then
    begin
    lblRefreshStatus.caption := 'automatic';
    edRefreshInterval.color := clBtnFace;
    pbSniffClick(nil);
    end
  else
    begin
    lblRefreshStatus.caption := 'manual';
    edRefreshInterval.color := clWindow;
    end;

end;

procedure TMain_F.pbCloseClick(Sender: TObject);
begin
  Close;

end;

procedure TMain_F.pbClearSniffedClick(Sender: TObject);
begin
  edPassword1.text := '';
  edPassword2.text := '';
  edPassword3.text := '';
  edPassword4.text := '';
end;

END.

